<p align="center"><img src="https://img.alicdn.com/tfs/TB1r74NJyLaK1RjSZFxXXamPFXa-1024-1024.png" align="center" width="175"></p>
<h1 align="center">Fish Redux</h1>

[![Build Status](https://travis-ci.org/alibaba/fish-redux.svg?branch=master)](https://travis-ci.org/alibaba/fish-redux) [![pub package](https://img.shields.io/pub/v/fish_redux.svg)](https://pub.dartlang.org/packages/fish_redux) [![codecov](https://codecov.io/gh/alibaba/fish-redux/branch/master/graph/badge.svg)](https://codecov.io/gh/alibaba/fish-redux)

## What is Fish Redux ?

Fish Redux is an assembled flutter application framework based on Redux state management.
It is suitable for building medium and large applications.

It has four characteristics:

> 1. Functional Programming

> 2. Predictable state container

> 3. Pluggable componentization

> 4. Non-destructive performance

## Architecture diagram

<img src="https://img.alicdn.com/tfs/TB1pkhoJr2pK1RjSZFsXXaNlXXa-1004-1370.png" width="500px" height="680px">

## Installation

[Go](https://pub.dartlang.org/packages/fish_redux#-installing-tab-)

## Documentation

Language: [English](doc/README.md) | [中文简体](doc/README-cn.md)

## Examples

-   [todo list](example) - a simple todo list demo.
-   run it:

```
cd ./example
flutter create .
flutter run
```

## What's the difference between 'Fish Redux' and 'Redux' ?

-   [answers](doc/concept/what's-the-diiference.md)

## Plugins

### Code Template

-   [Fish Redux Template For Android Studio](https://github.com/BakerJQ/FishReduxTemplateForAS), by BakerJQ.
-   [Fish Redux Template For VSCode](https://github.com/huangjianke/fish-redux-template), by huangjianke.

### Dev-Tools

-   Redux Inspector (using [Flutter Debugger](https://github.com/blankapp/flutter-debugger) and [flipperkit_fish_redux_middleware](https://pub.dartlang.org/packages/flipperkit_fish_redux_middleware)) for Fish Redux apps, by [JianyingLi](https://github.com/lijy91)

## License

-   Fish Redux is released under the Apache 2.0 license. See [LICENSE](LICENSE) for details.
